/*
 *   (C) COPYRIGHT Vincent S. Cojot and others 1996-1997
 *   All Rights Reserved
 *   Licensed Materials - Property of Vincent S. Cojot and others.
 *   Use, duplication or disclosure restricted by Vincent S. Cojot.
 */
#ifndef __TANK_H
#define __TANK_H

/* ------------------------------------------------*/
/* Ces fonctions servent a calculer La normale et le produit scalaire */
/* de deux vecteurs a deux dimensions (On approxime la troisieme */
/* Dimension car la lumiere est tres loin et on ne cherche pas a */
/* faire des ombres sur le sol. */
/* ------------------------------------------------*/

extern void Normale1 (float, float, float, float, float *, float *);
extern float ProduitScalaire (float, float, float, float);

/* ------------------------------------------------*/
/* Definitions des fonctions du corps du programme */
/* ------------------------------------------------*/
extern	GLvoid  initialize_lists (GLvoid);
extern	GLint  FindStartupPosition(GLvoid);
extern	GLfloat OrienteMissile(GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2);

GLvoid	initialize(GLvoid);	
GLvoid	drawScene(GLvoid);
void	resize(GLsizei Rwidth, GLsizei Rheight);
GLvoid	mouseDown(AUX_EVENTREC *event);
GLvoid	mouseUp(AUX_EVENTREC *event);
GLvoid	leftKey(GLvoid);
GLvoid	rightKey(GLvoid);
GLvoid	forwardKey(GLvoid);
GLvoid	backwardKey(GLvoid);
GLvoid  zoom30Key(GLvoid);
GLvoid  zoom45Key(GLvoid);
GLvoid  zoom60Key(GLvoid);
GLvoid  zoom90Key(GLvoid);
GLvoid  zoom120Key(GLvoid);
GLvoid	ToggleMode(GLvoid);
GLvoid  ToggleText (GLvoid);
GLvoid  ToggleHUD (GLvoid);
GLvoid  ToggleOver (GLvoid);
GLvoid  ToggleWingman (GLvoid);
GLvoid	ToggleSky(GLvoid);
GLvoid	ToggleFloor(GLvoid);
GLvoid	ToggleFog(GLvoid);
GLvoid  ChangeZoom(GLvoid);
GLvoid  DrawHUD (GLvoid);
GLvoid	DrawText (GLvoid);
GLvoid  MoveForward (GLvoid);
GLvoid  MoveBack (GLvoid);
GLvoid  MoveLeft (GLvoid);
GLvoid  MoveRight (GLvoid);
GLvoid	FireMissile(GLvoid);
GLvoid	ReverseSpeed(GLvoid);
GLvoid	CallOnLineHelp(GLvoid);
GLvoid	WhoIsPlayingWithMe(GLvoid);
GLvoid	makeMissileImages(GLvoid);
GLvoid  makeExplosionImages(GLvoid);
GLfloat	RockTank(GLvoid);
GLvoid  Show_init_progress(GLvoid);
GLvoid	DisplayInfoMessage(GLvoid);
GLvoid  ResetInfoMessage(GLvoid);
GLvoid	AddNewFriends(GLvoid);
GLvoid	TerminateEntireGame(GLvoid);
GLvoid	ExitNetworkGame(GLvoid);
GLvoid	JoinNetworkGame(GLvoid);
GLvoid	KilledFromNetworkGame(char *Who);
GLvoid	ManageNetworkStatus(GLvoid);
GLvoid	FlushGameState(GLvoid);
GLvoid	ShowEnemyNames(GLvoid);
GLvoid	ManageX11Windows(GLvoid);

/* ------------------------------------------------*/
/* Definitions des fonctions de gestions des objets animes autres */
/* que notre propre tank: Missiles, tanks enemis et explosions. */
/* ------------------------------------------------*/
extern	GLvoid  VerifierCollision (GLvoid);
extern	GLvoid	MoveMissiles(GLvoid);
extern	GLvoid	MoveMyMissile(GLvoid);
extern	GLvoid	MoveTanks(GLvoid);
extern	GLvoid	MoveDestroyedTanks(GLvoid);
extern	GLvoid	CallAllExplosions(GLvoid);

extern	GLvoid	InsertTank(TANK OneTank);
extern	GLvoid	InsertMissile(MISSILE OneMissile);
extern	GLvoid	InsertExplosion(EXPLOSION OneExplosion);
extern	GLvoid	InsertDestroyedTank(TANK OneTank);

extern	GLvoid	ManageNetwork(GLvoid);
extern	GLvoid	ForkIPCDaemon(GLvoid);
extern	GLvoid	CloseSegment(GLvoid);
extern	GLvoid	CopyPacketsInLocalMem (GLvoid);
extern	GLvoid	SendMyTankPacket(GLvoid);
extern	GLvoid	SendMyDyingTankPacket(GLvoid);
extern	GLvoid	SendMyMissilePacket(GLvoid);
extern	GLvoid	SendMyExplosionPacket(GLvoid);
extern	GLvoid	SendOnePacket(GLvoid *msg);
extern	GLvoid	ProcessCommandArgs(int argc,char *argv[]);

/* ------------------------------------------------*/
/* Definitions des matrices globales pour le jeu en reseau. */
/* On y trouve les definitions des structures de donnees de */
/* tous les tanks, missiles et explosions ainsi que des variables */
/* indiquant le nombre de ces objets. */
/* ------------------------------------------------*/
TANK		Tanks[MAX_TANKS];
MISSILE		Missiles[MAX_MISSILES];
EXPLOSION	Explosions[MAX_EXPLOSIONS];
TANK		DestroyedTanks[MAX_DESTROYED_TANKS];
GLint		explosion = 0;
GLint		tanks = 0;
GLint		FlyingMissile = 0;
GLint		MyFlyingMissile = 0;
GLint		destroyed = 0;

/* ------------------------------------------------*/
/* Ces definitions sont des variables statiques destinees a etre */
/* utlisees a des endroits tres divers du programme. */
/* On retrouve parmi celles-ci, la position en x,z du tank, sa */
/* vitesse longitudinale, sa vitesse anglaire et son orientation */
/* dans le plan du terrain d'evolution. */
/* ------------------------------------------------*/
GLfloat	scenePosx ;
GLfloat	scenePosz ;
GLfloat	sceneAngle;
GLfloat	RandomscenePosx ;
GLfloat	RandomscenePosz ;
GLfloat	RandomsceneAngle;
GLfloat MyTankPosx;
GLfloat MyTankPosz;
GLfloat MyTankAngle;

/* ------------------------------------------------*/
/* Angle du Wingman par rapport a notre propre tank. */
/* ------------------------------------------------*/
GLfloat WingAngle = 40.0;

/* ------------------------------------------------*/
/* Pour le debugging du reseau: Simule d'autres Tanks, */
/* missiles et explosions. */
/* ------------------------------------------------*/  
extern	GLvoid	SimulationInit(GLvoid);
extern	GLvoid	SimulationRun(GLvoid);

/* ------------------------------------------------*/
/* Position de l'explosion eventuelle et definitions diverses. */
/* ------------------------------------------------*/
GLfloat 	Explosx = 0, Explosy = 0, Explosz = 0;
GLfloat 	sceneY = -150.0, aspect, zoomFactor = 60 ;
GLfloat 	t1,t2,t3,t4;
float		xi,yi,xj,yj,res1,res2,res3,res4, RockFactor;
GLdouble	near_plane, far_plane;
GLsizei 	trueWidth = STARTUPWIDTH, trueHeight = STARTUPHEIGHT;
GLsizei		width = STARTUPWIDTH, height = STARTUPHEIGHT;
char		loginname[10];
char		hostname[10];
char		OurName[10];
char		StringTemp[80];
char		network_group[255];
u_short		network_port;
long		network_delay;
pid_t		ForkPID;
int		shmid1, shmid2, counter = 0;
GLint		floorSize = 250;
GLfloat		RadarX,RadarY,RadarDiffX,RadarDiffY;
GLfloat		fogColor[4] = {0.0, 0.0, 0.0, 1.0};
TANK		OneTank;
MISSILE		OneMissile;
EXPLOSION	OneExplosion;
TANK		OneDestroyedTank;
MESSAGE		InfoMessage;
STATUS_IPC	*GameStatus;
PTANK		OneTankPacket;
PMISSILE	OneMissilePacket;
PEXPLOSION	OneExplosionPacket;


/* ------------------------------------------------*/
/* Tous les etats possible du jeu avec leurs valeurs initiales */
/* ------------------------------------------------*/
GLint	score = 0;		/* Score du joueur. */
GLint	wingman = 0;		/* Mode de vue Wingman? */
GLint	overhead = 0;		/* Mode de vue Overhead? */
GLint	mode = 0;		/* Mode Shading ou WireFrame? */
GLint	hud = 1;		/* Affichage du HUD? */
GLint	Fog = 1;		/* Presence de brouillard? */
GLint	explosion_count = 0;	/* Nombre d'explosions (obsolte). */
GLint	scoretxt = 0;		/* Flag d'affichage d'un text de score.. */
GLint	Skymode = 1;		/* Affichage du ciel? */
GLint	Floor = 0;		/* Affichage du plancher complexe? */
GLint	Alive = 1;		/* Par defaut Alive = TRUE car on essaie */
				/* de detecter un jeu network des que */
				/* le jeu commence a fonctionner. */
GLint	Network = 0;		/* Joue-t-on un jeu en reseau? */
GLint	GameTerminating = 0;	/* Le jeu est-t-il en train de finir? */
GLint	ShowNames = 1;		/* Affiche-t-on les noms des enemis?*/
GLint	i, j;
GLfloat	GameAge;

GLfloat	FiredRecently = 0.0;	/* Temps depuis lequel on a tire.. */

/* ------------------------------------------------*/
/* Les vitesses caracterisant le deplacement de notre tank */
/* ------------------------------------------------*/
GLint	LongSpeed = 0, OldLongSpeed =0, VeryOldLongSpeed = 0 ;
GLint	RotaSpeed = 0 ;

/* ------------------------------------------------*/
/* Variables destinees a permettre la realisation d'un timer */
/* qui amplifie ou attenue la vitesse en fonction du Frame rate */
/* ------------------------------------------------*/

struct	timeval temps;	/* Variable de type Timeval destinee a recevoir */
			/* les informations de gettimeofday. */
struct	timeval temps2;	/* Variable de type Timeval destinee a recevoir */
			/* les informations de gettimeofday. */
GLfloat	CurrentDate;	/* La date actuelle, en microsecondes. */
GLfloat	TimeInterval;	/* Le temps entre deux calculs de la date actuelle. */
GLfloat	TimeTravel;	/* Le facteur multiplicatif du deplacement en */
GLfloat	OldTimeTravel;	/* fonction du temps pour dessiner les images. */

float	InertiaTime;		/* Variables destinees a donner une allure */
float	InertiaTimeDifference;	/* realiste et inertielle aux deplacements */
				/* de notre tank. */

/* ------------------------------------------------*/
/* Grosse Matrice a quatre dimensions contenant toutes les differentes */
/* Vues du missile avec ses textures... */
/* ------------------------------------------------*/
GLfloat
MissileImages[NB_OF_MISSILE_TEXTURES][MissImageWidth][MissImageHeight][4];

/* ------------------------------------------------*/
/* Grosse Matrice a quatre dimensions contenant toutes les differentes */
/* Frames des explosions avec leurs textures... */
/* ------------------------------------------------*/
GLfloat
ExplosionImages[NB_OF_EXPL_TEXTURES][ExplImageWidth][ExplImageHeight][4];

/* ------------------------------------------------*/
/* Routines servant a loader les images (voir readtga.c) */
/* ------------------------------------------------*/
extern int read_Miss_tga (MISS_IMAGE *, char *, int width, int length);
extern int read_Expl_tga (EXPL_IMAGE *, char *, int width, int length);

/* ------------------------------------------------*/
/* Various X stuff.... */
/* ------------------------------------------------*/
XWMHints       *wmhints;
XClassHint     *classhints;
XSizeHints     *sizehints;
char           *window_Name;
XTextProperty  windowName;
FILE		*terminal_fp;
#endif
